unit UltraNet32;

{$TYPEDADDRESS OFF} // Unit must be compiled without type-checked pointers.
interface

uses Windows, ActiveX, Classes, Graphics, OleCtrls, StdVCL, SysUtils;

const
  // TypeLibrary 
  UltraNet32MajorVersion = 1;
  UltraNet32MinorVersion = 1;

  LIBID_UltraNet32: TGUID = '{C05D4F20-940B-11D6-B38C-00C0DFF68220}';
  IID_IBackInterface: TGUID = '{C949B982-6E75-11D7-8DE3-00C0DFF68220}';
  CLASS_BackInterface: TGUID = '{C949B984-6E75-11D7-8DE3-00C0DFF68220}';
  IID_IEmulator: TGUID = '{CEDB4790-C69C-4060-AD65-6B0ED1CD54B2}';
  IID_IUltraNetOleServ: TGUID = '{69AE2FD6-5D74-4BB1-A62C-B8182EA6AFE0}';
  CLASS_UltraNetOleServ: TGUID = '{1B557202-58BB-4DC9-A650-3BB491FF0BCF}';

//    SplitList
  FieldSeparator : char = #9;
  RecordSeparator : char = #13;
type
  LongWord  = Cardinal;
  //  
  VarType = (vtBoolean, vtByte, vtWord, vtDWord, vtShortint, vtInteger, vtLongint, vtFloat, vtTimer, vtUnknown);
  //   
  VarValue = record
    case Typ: VarType of
      vtInteger : (I : Smallint);
      vtFloat : (F : single);
      vtTimer : (T : longint);
      vtBoolean : (B : boolean);
      vtByte    : (BT : byte);
      vtWord    : (W : word);
      vtDWord    : (D : CARDINAL);
      vtShortint : (S : ShortInt);
      vtLongint  : (L : Longint);
    end;
  PVarInfo = ^VarInfo;
  VarInfo = packed record
    Name : shortstring; //  
    Val : VarValue;     //  
    Desc : shortstring; //  
    Node : integer;     //  
    Index : integer;    //    
    Row : integer;      // { }
  end;
{ -    }
  TComVarInfo = class
  public
    Name : WideString;   // 
    Typ : WideString;    // 
    Val : VarValue;      // 
    ValCache : VarValue; //  
    FlagCache:boolean;   //    
    Index : integer;     //    Ultranet32
    TagIndex : integer;  // { }
    DatIndex : integer;  // { }  
    Instance : integer;  // { }    Ultranet32
    Valid:boolean;
    constructor Create(vName,vTyp : WideString); //  
    destructor Destroy; override; // 
  end;
//  
    PConfRec =^TConfRec;
    TConfRec = packed record
    AnswerID : word;    //{  = $0000}
 CntInputVar : word;    //{-  }
CntPublicVar : word;    //{-  }
CntOutputVar : word;    //{-  }
 LstInputVar : word;    //{   }
LstPublicVar : word;    //{   }
LstOutputVar : word;    //{   }
     AbsTime : word;    //{    }
  TimeInTick : single;  //{    }
 CompileTime : longint; //{,   }
   VersionID : word;    //{  XX.XX}
   ProgramID : byte;    //{ }
       end;
// *********************************************************************//
//  Ultranet32
// *********************************************************************//
  IBackInterface = interface;
  IEmulator = interface;
  IUltraNetOleServ = interface;
  IUltraNetOleServDisp = dispinterface;
  BackInterface = IBackInterface;
  UltraNetOleServ = IUltraNetOleServ;

  IBackInterface = interface(IUnknown)
    ['{C949B982-6E75-11D7-8DE3-00C0DFF68220}']
    function  SendRequest(InRequest: OleVariant; var OutRequest: OleVariant): Integer; safecall;
    procedure BackMessage(const Msg: WideString); safecall;
  end;
//
  IEmulator = interface(IUnknown)
    ['{CEDB4790-C69C-4060-AD65-6B0ED1CD54B2}']
//    Ultranet32
    procedure CreateEmuNode(Node: Integer; const BackInterface: IBackInterface;
                            var Connected: WordBool); safecall;
//    Ultranet32
    procedure DestroyEmuNode(Node: Integer); safecall;
  end;

  IUltraNetOleServ = interface(IDispatch)
    ['{69AE2FD6-5D74-4BB1-A62C-B8182EA6AFE0}']
    function  AddVariable(const Name: WideString; const Typ: WideString): Integer; safecall;
    function  GetValueByName(const Name: WideString): OleVariant; safecall;
    function  GetValue(Index: Integer): OleVariant; safecall;
    procedure RemoveVar(Index: Integer); safecall;
    procedure SetValueByName(const Name: WideString; const Typ: WideString; Value: OleVariant); safecall;
    function  GetVarList(Node: Integer): WideString; safecall;
    function  GetNodeList: OleVariant; safecall;
    function  GetValues(IndexArray: OleVariant): OleVariant; safecall;
    function  GetNodeConf(Node: Integer): OleVariant; safecall;
    procedure SetValue(Index: Integer; Value: OleVariant); safecall;
    procedure AddNode(Node: Integer); safecall;
    function  StateNode(Node: Integer): Integer; safecall;
    procedure DecInstance(IndexArray: OleVariant); safecall;
    function  SetValues(IndexArray: OleVariant; VarArray: OleVariant): Integer; safecall;
    function  GetProjectName(Node: Integer): WideString; safecall;
    procedure SendPacket(var vTo: OleVariant; var vType: OleVariant; var vLen: OleVariant; 
                         vWait: OleVariant; var vData: OleVariant); safecall;
    function  GetSelfNode: Integer; safecall;
    procedure GetNameTypeByIndex(Index: Integer; out Name: OleVariant; out Typ: OleVariant); safecall;
    function  GetTypes(IndexArray: OleVariant; out OutArray: OleVariant): Integer; safecall;
    function  AddAllVariables(const Names: WideString; const Types: WideString; 
                              out Indexs: OleVariant): Integer; safecall;
    function  RegisterVariable(const Name: WideString; const Typ: WideString): Integer; safecall;
    procedure RefreshNodeConf(Node: Integer); safecall;
//
    function  ValidValuesFromNode(Node: Integer): WordBool; safecall;
    function  ValidVarByName(const Name: WideString): WordBool; safecall;
    function  ValidVarByIndex(Index: Integer): WordBool; safecall;
    function  ValidArray(Indexs: OleVariant): OleVariant; safecall;
  end;

  IUltraNetOleServDisp = dispinterface
    ['{69AE2FD6-5D74-4BB1-A62C-B8182EA6AFE0}']
//     
    function  AddVariable(const Name: WideString; const Typ: WideString): Integer; dispid 1;
// Integer-     
    function  GetValueByName(const Name: WideString): OleVariant; dispid 2;
// Integer-     
    function  GetValue(Index: Integer): OleVariant; dispid 3;
//  (  )
    procedure RemoveVar(Index: Integer); dispid 4;
//      
    procedure SetValueByName(const Name: WideString; const Typ: WideString; Value: OleVariant); dispid 5;
//     
    function  GetVarList(Node: Integer): WideString; dispid 6;
//   
    function  GetNodeList: OleVariant; dispid 7;
//     Ultranet32 
    function  GetValues(IndexArray: OleVariant): OleVariant; dispid 8;
//  
    function  GetNodeConf(Node: Integer): OleVariant; dispid 9;
// Integer-     ,   Ultranet32
    procedure SetValue(Index: Integer; Value: OleVariant); dispid 10;
//   Ultranet32  
    procedure AddNode(Node: Integer); dispid 11;
//  
    function  StateNode(Node: Integer): Integer; dispid 12;
//     Ultranet32 
    procedure DecInstance(IndexArray: OleVariant); dispid 13;
//       Ultranet32
    function  SetValues(IndexArray: OleVariant; VarArray: OleVariant): Integer; dispid 14;
//    
    function  GetProjectName(Node: Integer): WideString; dispid 15;
//   
    procedure SendPacket(var vTo: OleVariant; var vType: OleVariant; var vLen: OleVariant;
                         vWait: OleVariant; var vData: OleVariant); dispid 16;
//    Ultranet-
    function  GetSelfNode: Integer; dispid 17;
//      
    procedure GetNameTypeByIndex(Index: Integer; out Name: OleVariant; out Typ: OleVariant); dispid 18;
//     
    function  GetTypes(IndexArray: OleVariant; out OutArray: OleVariant): Integer; dispid 19;
//    Ultranet32,   StringList-   ,     ( SCADA)
    function  AddAllVariables(const Names: WideString; const Types: WideString;
                              out Indexs: OleVariant): Integer; dispid 20;
//   Ultranet32 ( SCADA)
    function  RegisterVariable(const Name: WideString; const Typ: WideString): Integer; dispid 21;
//   Ultranet32 ( DNC32)
    procedure RefreshNodeConf(Node: Integer); dispid 22;
//     
    function  ValidValuesFromNode(Node: Integer): WordBool; dispid 23;
//     
    function  ValidVarByName(const Name: WideString): WordBool; dispid 24;
//     
    function  ValidVarByIndex(Index: Integer): WordBool; dispid 25;
//      
    function  ValidArray(Indexs: OleVariant): OleVariant; dispid 26;

  end;
// *********************************************************************//
  CoUltraNetOleServ = class
    class function Create: IUltraNetOleServ;
    class function CreateRemote(const MachineName: string): IUltraNetOleServ;
  end;
// VarValue     Integer   
  function VarValueToInteger(V:VarValue):integer;
//   Ole     VarValue   
  procedure MakeOleValue(Val:OleVariant;var V:VarValue);
//  VarValue  Ole
  procedure MakeOle(V:VarValue;var Val:OleVariant);
//   Integer     VarValue   
  procedure MakeValue(Val:integer;var V:VarValue);
// VarValue     
  function ValueToStr(Val:VarValue):string;
//      VarValue,       V.Typ
  procedure StrToValue(Vl:string;var V:VarValue);
// Integer     
  function GetStrTimeVal(Val:longint):string;
//     
  function CheckTimerConst(const Val:string):boolean;
//      Integer-
  function CompileTimerType(const Val:string):integer;
//     ,    
  function GetProjectName(ProgramID : integer):string;
//    OleVariant 
  function UnpackGlobConf(Pack:OleVariant):TConfRec;
//         TComVarInfo - 
  function SplitList(Str:string) : TList;
//   
  function StrToType(Name:shortstring):VarType;

const
// sizeof(  VarType)
  VarLen : array [VarType] of byte = (1,1,2,4,1,2,4,4,4,0);
//    VarType
  TypeName : array [VarType] of string[10] = ('Boolean','Byte','Word','DWord','Shortint','Integer','Longint','Float','Timer','Unknown');
//-----------------------------------------------------------------------------------------------------------
implementation
uses ComObj;
//-----------------------------------------------------------------------------------------------------------
//  Ultranet32 c
class function CoUltraNetOleServ.Create: IUltraNetOleServ;
begin
  Result := CreateComObject(CLASS_UltraNetOleServ) as IUltraNetOleServ;
end;
//-----------------------------------------------------------------------------------------------------------
//  Ultranet32 c
class function CoUltraNetOleServ.CreateRemote(const MachineName: string): IUltraNetOleServ;
begin
  Result := CreateRemoteComObject(MachineName, CLASS_UltraNetOleServ) as IUltraNetOleServ;
end;
//-----------------------------------------------------------------------------------------------------------
//  TComVarInfo
constructor TComVarInfo.Create(vName,vTyp : WideString);
begin
  inherited Create;
  Instance:=0;
  Name:=vName;
  Typ:=vTyp;
  Valid:=false;
  fillchar(Val,sizeof(Val),0);
  Val.Typ:=StrToType(vTyp);
  move(Val,ValCache,sizeof(Val));
  FlagCache:=false;
end;
//-----------------------------------------------------------------------------------------------------------
//  TComVarInfo
destructor TComVarInfo.Destroy;
begin
  inherited;
end;
//-----------------------------------------------------------------------------------------------------------
// VarValue     Integer   
function VarValueToInteger(V:VarValue):integer;
var Res:integer;
begin
   case V.Typ of
     vtInteger: Res:=V.I;
     vtFloat: begin
                if ((V.D shl 1) and $FF000000) = $FF000000
                   then Res:=0
                   else move(V.F,Res,4);
              end;
     vtTimer: Res:=V.T;
     vtBoolean: begin
       if V.B then
         Res:=1
       else
         Res:=0;
     end;
     vtByte: Res:=V.BT;
     vtWord: Res:=V.W;
     vtDWord: move(V.D,Res,4);
     vtShortint: Res:=V.S;
     vtLongint: Res:=V.L;
     else
       Res:=0;
   end;
  Result:=res;
end;
//-----------------------------------------------------------------------------------------------------------
procedure MakeOle(V:VarValue;var Val:OleVariant);
var
  Value:OleVariant;
begin
  case V.Typ of
    vtDWord: begin
      Value:=V.D;
      VarCast(Val,Value,VT_UI4)
    end;
    vtByte: begin
      Value:=V.BT;
      VarCast(Val,Value,VT_UI1)
    end;
    vtWord: begin
      Value:=V.W;
      VarCast(Val,Value,VT_UI2)
    end;
    vtShortint: begin
      Value:=V.S;
      VarCast(Val,Value,VT_I1)
    end;
    vtLongint: begin
      Value:=V.L;
      VarCast(Val,Value,VT_I4)
    end;
    vtInteger: begin
      Value:=V.I;
      VarCast(Val,Value,VT_I2)
    end;
    vtFloat: begin
      Value:=V.F;
      VarCast(Val,Value,VT_R4)
    end;
    vtTimer: begin
      Value:=V.T;
      VarCast(Val,Value,VT_UI4)
    end;
    vtBoolean: begin
      Value:=V.B;
      VarCast(Val,Value,VT_BOOL)
     end;
  end;
end;
//-----------------------------------------------------------------------------------------------------------
//   Integer     VarValue   
procedure MakeValue(Val:integer;var V:VarValue);
var
  F : single absolute Val;
begin
  case V.Typ of
    vtDWord: begin
      V.D:=longword(Val);
    end;
    vtByte: begin
      if Val<0 then Val:=0 else
        if Val>255 then Val:=255;
      V.BT:=Val;
    end;
    vtWord: begin
      if Val<0 then Val:=0 else
        if Val>65535 then Val:=65535;
      V.W:=Val;
    end;
    vtShortint: begin
      if Val<=-128 then Val:=-128 else
        if Val>=127 then Val:=127;
      V.S:=Val
    end;
    vtLongint: begin
      V.L:=Val;
    end;
    vtInteger: begin
      if Val<=-32768 then Val:=-32768 else
        if Val>=32767 then Val:=32767;
      V.I:=Val;
    end;
    vtFloat: begin
      V.F:=F;
    end;
    vtTimer: begin
      V.T:=Val;
    end;
    vtBoolean: begin
      V.B:=Val=1;
    end;
  end;{case}
end;
//
//   Ole     VarValue   
procedure MakeOLEValue(Val:OleVariant;var V:VarValue);
begin
  case V.Typ of
    vtDWord: begin
      V.D:=Val;
    end;
    vtByte: begin
      if Val<0 then Val:=0 else
        if Val>255 then Val:=255;
      V.BT:=Val;
    end;
    vtWord: begin
      if Val<0 then Val:=0 else
        if Val>65535 then Val:=65535;
      V.W:=Val;
    end;
    vtShortint: begin
      if Val<=-128 then Val:=-128 else
        if Val>=127 then Val:=127;
      V.S:=Val
    end;
    vtLongint: begin
      V.L:=Val;
    end;
    vtInteger: begin
      if Val<=-32768 then Val:=-32768 else
        if Val>=32767 then Val:=32767;
      V.I:=Val;
    end;
    vtFloat: begin
      V.F:=Val;
    end;
    vtTimer: begin
      V.T:=Val;
    end;
    vtBoolean: begin
      V.B:=Val=1;
    end;
  end;{case}
end;
//-----------------------------------------------------------------------------------------------------------
// VarValue     
function ValueToStr(Val:VarValue):string;
var
  e,d:integer;
begin
   case Val.Typ of
     vtInteger: Result:=IntToStr(Val.I);
     vtFloat: begin
                if ((Val.D shl 1) and $FF000000) = $FF000000
                   then Result:='INVALID'
                   else Result:=trim(Format('%8.5f', [Val.F]));//     FloatToStr(Val.F);
              end;
     vtTimer: Result:=GetStrTimeVal(Val.T);
     vtBoolean: begin
       if Val.B then
         Result:='TRUE'
       else
         Result:='FALSE'
     end;
     vtByte: Result:=IntToStr(Val.BT);
     vtWord: Result:=IntToStr(Val.W);
     vtDWord:
       begin
         if (longint(Val.D)<0) then begin
            asm
               mov  eax,Val.D
               xor  edx,edx
               mov  ecx,100000000
               div  ecx
               mov  d,eax
               mov  e,edx
               end;
            Result:=intToStr(d)+intToStr(e)
           end
         else
            Result:=intToStr(longint(Val.D));
       end;
     vtShortint: Result:=IntToStr(Val.S);
     vtLongint: Result:=IntToStr(Val.L);
     else
       Result:='Unknown';
   end;{case}
end;
//-----------------------------------------------------------------------------------------------------------
//      VarValue,       V.Typ
procedure StrToValue(Vl:string;var V:VarValue);
var i:integer;
    v1,v2:string;
    D:cardinal;
begin
  case V.Typ of
      vtInteger:  V.I:=StrToInt(Vl);
      vtFloat:    V.F:=StrToFloat(Vl);
      vtTimer:    V.T:=CompileTimerType(Vl);//      StrToInt(Vl);
      vtBoolean:  begin
                    if (UpperCase(Vl) = 'FALSE') or (UpperCase(Vl)='TRUE')
                      then
                        V.B:=UpperCase(Vl)[1]='T'
                      else
                        V.B:=StrToInt(Vl)>0
                  end;
      vtByte:     V.BT:=StrToInt(Vl);
      vtWord:     V.W:=StrToInt(Vl);
      vtDWord:    begin
                     V1:=Vl[1];
                     V2:=copy(Vl,2,length(Vl)-1);
                     D:=StrToInt(V1);
                     for i:=1 to length(Vl)-1 do
                       asm
                         mov ebx,10
                         mov eax,D
                         xor edx,edx
                         mul ebx
                         mov D,eax
                       end;
                     V.D:=D;
                     if v2<>'' then
                       V.D:=V.D+StrToInt(V2);
                  end;
      vtShortint: V.S:=StrToInt(Vl);
      vtLongint:  V.L:=StrToInt(Vl);
   end;
end;
//-----------------------------------------------------------------------------------------------------------
// Integer     
function GetStrTimeVal(Val:longint):string;
var
   I : integer;
   J : longint;
   T : Comp;
   D : shortint;
   R : string;
   C : string[5];
begin
   D:=1;{ }
   {}
   T:=365*24*60*60;
   T:=(T*100)/D;
   I:=0;
   while Val>=T do begin
      inc(I);
      Val:=round(Val-T);
      end;
   if I=0 then
      R:=''
   else begin
      str(I,R);
      R:=R+'y';
      end;
   {}
   J:=24*60*60*100 div D;
   I:=Val div J;
   if I<>0 then begin
      str(I,C);
      R:=R+C+'d';
      end;
   Val:=Val-J*I;
   {}
   J:=60*60*100 div D;
   I:=Val div J;
   if I<>0 then begin
      str(I,C);
      R:=R+C+'h';
      end;
   Val:=Val-J*I;
   {}
   J:=60*100 div D;
   I:=Val div J;
   if I<>0 then begin
      str(I,C);
      R:=R+C+'m';
      end;
   Val:=Val-J*I;
   {}
   J:=100 div D;
   I:=Val div J;
   if I<>0 then begin
      str(I,C);
      R:=R+C+'s';
      end;
   Val:=Val-I*J;
   if R='' then
      R:='0s';
   if Val<>0 then begin
      I:=Val*D;
      str(I,C);
      if C[0]=#1 then
         C:='0'+C;
      R:=R+C;
      end;
   GetStrTimeVal:=R;
end;
//-----------------------------------------------------------------------------------------------------------
//     
function CheckTimerConst(const Val:string):boolean;
var
   D,H,M,S : boolean;
       Tmp : string;
         I : integer;
begin
   Tmp:=AnsiUpperCase(Val);
{}
   Result:=true;
{}
   if Tmp='TSTART' then
      exit;
{}
   D:=false;
   H:=false;
   M:=false;
   S:=false;
{}
   for I:=1 to length(Tmp) do begin
      case Tmp[I] of
         '0'..'9' : begin
            end;{begin}
         'S' : begin
            if S then begin
               Result:=false;
               break;
               end{if}
            else
               S:=true;
            end;{begin}
         'M' : begin
            if M then begin
               Result:=false;
               break;
               end{if}
            else
               M:=true;
            end;{begin}
         'H' : begin
            if H then begin
               Result:=false;
               break;
               end{if}
            else
               H:=true;
            end;{begin}
         'D' : begin
            if D then begin
               Result:=false;
               break;
               end{if}
            else
               D:=true;
            end;{begin}
         else begin
            Result:=false;
            break;
            end;{else}
         end;{case}
      end;{for}
end;
//-----------------------------------------------------------------------------------------------------------
//      Integer-
function CompileTimerType(const Val:string):integer;
const
    Sec = 100;
    Min = 60*Sec;
    Hour= 60*Min;
    Day = 24*Hour;
var
   I,J,K : integer;
       S : string;
begin
   S:=AnsiUpperCase(Val);
   if not CheckTimerConst(Val) then
      raise Exception.Create('Invalid TIMER constant : '+Val);
   J:=0;
   if S='TSTART' then
      I:=$80000000
   else begin
      I:=0;
      for K:=1 to length(S) do begin
         case S[K] of
            '0'..'9' : begin
                J:=J*10+(byte(S[K]) and $F);
                end;{begin}
            'D' : begin
                I:=I+J*Day;
                J:=0;
                end;{begin}
            'H' : begin
                I:=I+J*Hour;
                J:=0;
                end;{begin}
            'M' : begin
                I:=I+J*Min;
                J:=0;
                end;{begin}
            'S' : begin
                I:=I+J*Sec;
                J:=0;
                end;{begin}
            end;{case}
         end;{for}
      end;{else}
   Result:=I+J
end;
//-----------------------------------------------------------------------------------------------------------
//     ,    
function GetProjectName(ProgramID : integer):string;
begin
  case ProgramID of
  1 : result:='Old Project(version for DOS)';{ PLC  8088}
  2 : result:='Small PLC';{ }
  3 : result:='Debbuger(version for DOS)';{ PLC.EXE}
  4 : result:='PLCNET Driver(version for OSSY)';{OSSY }
  5 : result:='MicroPLC (MicroUltronic)';
  6 : result:='Project UltraLogik';{ PLCWIN}
  7 : result:='SCADA Ultralogik';{SCADA PLCWIN}
  8 : result:='Debugger UltraLogik';{ PLCWIN}
  9 : result:='UltraNet32 Server'; { UltraNet32}
 $A : result:='Project UltraLogik32';{ PLCWIN32}
 $B : result:='System Loader';{ATMega128}
 $C : result:='Emulator UltraLogik32';
 $D : result:='DNC terminal'; {}
 $E : result:='USB-RS485 Adapter'; {}
 $F : result:='PLCNET Terminal'; {}
  else
    result:='UnKnown';
  end; {case}
end;
//-----------------------------------------------------------------------------------------------------------
//    OleVariant 
function UnpackGlobConf(Pack:OleVariant):TConfRec;
var
  C,P: Pointer;
  Res : TConfRec;
begin
  C:=VarArrayLock(Pack);
  P:=@Res;
  Move(C^,P^,27);
  VarArrayUnlock(Pack);
  Result:=Res;
end;
//-----------------------------------------------------------------------------------------------------------
//         TComVarInfo - 
function SplitList(Str:string) : TList;
var
  I : integer;
  SName, SType : ShortString;
  V : TComVarInfo;
begin
  Result:=TList.Create;
  repeat
    I:=Pos(FieldSeparator,Str);
    if I=0
      then Str:=''
      else
        begin
          SName:=Copy(Str,1,I-1);
          Delete(Str,1,I);
          I:=Pos(RecordSeparator,Str);
          SType:=Copy(Str,1,I-1);
          Delete(Str,1,I);
          V:=TComVarInfo.Create(Sname,SType);
          Result.Add(V);
       end;
  until Str='';
end;
//-----------------------------------------------------------------------------------------------------------
//   
function StrToType(Name:shortstring):VarType;
begin
  Name:=uppercase(Name);
  if Name='INTEGER' then
    Result:=vtInteger
  else if Name='TIMER' then
    Result:=vtTimer
  else if Name='FLOAT' then
    Result:=vtFloat
  else if Name='BOOLEAN' then
    Result:=vtBoolean
  else if Name='BYTE' then
    Result:=vtByte
  else if Name='WORD' then
    Result:=vtWord
  else if Name='DWORD' then
    Result:=vtDWord
  else if Name='SHORTINT' then
    Result:=vtShortint
  else if Name='LONGINT' then
    Result:=vtLongint
  else if Name='?' then
    Result:=vtFloat
  else
    Result:=vtUnknown;
end;
//-----------------------------------------------------------------------------------------------------------

end.
