unit uDemo;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtDlgs, ExtCtrls, StdCtrls, UltraNet32, ComCtrls;

type
  TfrmDemo = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Label1: TLabel;
    Label6: TLabel;
    btnAddNode: TButton;
    eNode: TEdit;
    btnRemoveNode: TButton;
    eState: TEdit;
    Panel5: TPanel;
    btnGetVarList: TButton;
    btnGetValues: TButton;
    btnSetValues: TButton;
    lbValues: TListBox;
    lbVars: TListBox;
    Label5: TLabel;
    eVarListValue: TEdit;
    btnSetValueToList: TButton;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    eVarName: TEdit;
    eVarType: TEdit;
    eVarValue: TEdit;
    btnSetValueByName: TButton;
    btnSetValueByIndex: TButton;
    Label7: TLabel;
    Label8: TLabel;
    btnConnect: TButton;
    btnGetNodeList: TButton;
    btnDisconnect: TButton;
    lbNodes: TListBox;
    NodeList: TLabel;
//  
    procedure btnGetNodeListClick(Sender: TObject);
//  Ultranet32
    procedure btnConnectClick(Sender: TObject);
//  Ultranet32
    procedure btnDisconnectClick(Sender: TObject);
//   Ultranet32  
    procedure btnAddNodeClick(Sender: TObject);
// ,  
    procedure FormCreate(Sender: TObject);
//       Ultranet32  
    procedure lbNodesClick(Sender: TObject);
//    
    procedure btnGetVarListClick(Sender: TObject);
//      -   
    procedure btnRemoveNodeClick(Sender: TObject);
//       (    )
    procedure btnGetValuesClick(Sender: TObject);
//          
    procedure lbVarsClick(Sender: TObject);
//    (LastVar)  (         {XX.Name})
    procedure btnSetValueByNameClick(Sender: TObject);
//        Ultranet32)
    procedure btnSetValueByIndexClick(Sender: TObject);
//    lbValues    lbVars)
    procedure btnSetValuesClick(Sender: TObject);
//        lbValues
    procedure lbValuesClick(Sender: TObject);
//    (LastListVar)   lbValues
    procedure btnSetValueToListClick(Sender: TObject);
  end;
//--------------------------------------------------------------------------------------------------------------------
var
  frmDemo: TfrmDemo;
  UN32:IUltraNetOLEServ; //Ultranet COM 
  State:integer;         //  
  LastVar:PVarInfo;      //     (lbVars) 
  LastListVar:PVarInfo;  //     (lbValues) 

//       lbVars,    lbValues -
// -     ,     lbVars;
//  LastVar   ( )    lbVars,
//  LastListVar   ( )    lbVars
//     lbValues
//--------------------------------------------------------------------------------------------------------------------
implementation

{$R *.DFM}

//--------------------------------------------------------------------------------------------------------------------
//  
procedure TfrmDemo.btnGetNodeListClick(Sender: TObject);
var
  PackedConf,NodeList:OleVariant;
  Count,Node,I:integer;
  Conf:TConfRec;
  NumberVars,ProjectName:string;
begin
  if UN32<>nil then
    begin
      // lbNodes(ListBox) -  ( -   -  )
      lbNodes.Items.Clear;
      //   ( )
      NodeList:=UN32.GetNodeList;
      //   
      Count:=VarArrayHighBound(NodeList, 1);
      // 
      for I:=0 to Count do begin
        //     NodeList
        Node:=NodeList[I];
        //  UN32   
        PackedConf:=UN32.GetNodeConf(Node);
        // 
        Conf:=UnpackGlobConf(PackedConf);
        //  ,   
        ProjectName:=GetProjectName(Conf.ProgramID);
        //   ,   
        NumberVars:=inttostr(Conf.CntPublicVar);
        //   ,   
        lbNodes.Items.Add(IntToStr(Node)+' - '+NumberVars+' - '+ProjectName);
      end;
    end
end;
//--------------------------------------------------------------------------------------------------------------------
//  Ultranet32
procedure TfrmDemo.btnConnectClick(Sender: TObject);
begin
  UN32:=CoUltraNetOleServ.Create;
end;
//--------------------------------------------------------------------------------------------------------------------
//  Ultranet32
procedure TfrmDemo.btnDisconnectClick(Sender: TObject);
begin
//()  
  btnRemoveNode.Click;
//  
  lbNodes.Items.Clear;
// 
  eNode.Text:='';
  eState.Text:='';
  eVarListValue.Text:='';
  eVarValue.Text:='';
//  Ultranet32
  UN32:=nil;
end;
//--------------------------------------------------------------------------------------------------------------------
//   Ultranet32  
procedure TfrmDemo.btnAddNodeClick(Sender: TObject);
var
  fNode:integer;
  I:integer;
begin
  if (eNode.Text='') or (UN32=nil) then exit;
//      Ultranet32  
  fNode:=StrToInt(eNode.Text);
  // fNode    [0..255],
  //       
{LOOP:}
//  
  Un32.AddNode(fNode);
  I:=100;
  repeat
    sleep(10);
//  
    State:=UN32.StateNode(fNode);
    dec(I);
  until (State=1) or (I=0);
//     ( ,
//    ),  State=1,  State=0
  if State=1
    // ,  Ultranet32       (, , )
    then eState.Text:='Adding OK'
    else
      begin
        eState.Text:='Adding WAIT';
        //   ,      
        //  LOOP ()   ( )
        {goto LOOP}
      end
end;
//--------------------------------------------------------------------------------------------------------------------
// ,  
procedure TfrmDemo.FormCreate(Sender: TObject);
begin
//  
  UN32:=nil;
  LastVar:=nil;
  LastListVar:=nil;
end;
//--------------------------------------------------------------------------------------------------------------------
//       Ultranet32  
procedure TfrmDemo.lbNodesClick(Sender: TObject);
var Node:string;
begin
  Node:='';
  if lbNodes.Items.Count>0 then
    begin
      //  
      Node:=lbNodes.Items[lbNodes.ItemIndex];
      //  
      Node:=copy(Node,1,pos(' ',Node)-1);
      eNode.Text:=Node;
    end
end;
//--------------------------------------------------------------------------------------------------------------------
//    
procedure TfrmDemo.btnGetVarListClick(Sender: TObject);
var
  PVar : PVarInfo;
  fNode:integer;
  I:integer;
  VList:TList;
  V    : TComVarInfo;
  StrList:string;
begin
//    Ultranet32   
  if (UN32=nil) or (State=0) then exit;
//  
  fNode:=StrToInt(eNode.Text);
//     
  StrList:=UN32.GetVarList(fNode);
//        
  VList:=SplitList(StrList);
//  lbVars(VarList)
  lbVars.Items.Clear;
//  
  for I:=0 to VList.Count-1 do
    begin
       V:=VList[I];
       //    (, , ,  ,,   Ultranet32)
       new(PVar);
       //   
       PVar^.Name:=V.Name;
       //  ,    
       PVar^.Node:=fNode;
       //   
       PVar^.Val.Typ:=V.Val.Typ;
       //   
       PVar^.Val.T:=0;
       //   
       PVar^.Desc:='';
       //   ,       Ultranet32
       PVar^.Index:=UN32.AddVariable(inttohex(PVar.Node,2)+'.'+PVar.Name,TypeName[PVar.Val.Typ]);
       // -      lbVars(VarList)
       lbVars.Items.AddObject(V.Name+' - '+TypeName[PVar^.Val.Typ],TObject(PVar));
       //  
       V.Free;
    end;
//  ,      (, )
  VList.Free;
end;
//--------------------------------------------------------------------------------------------------------------------
//      -   
procedure TfrmDemo.btnRemoveNodeClick(Sender: TObject);
var
  V : OleVariant; //  ,  
  I : integer;
  PVar : PVarInfo;
begin
//    Ultranet32
  if UN32=nil then exit;
//   ,   Ultranet32
  V:=VarArrayCreate([0,0],varInteger);
  VarArrayRedim(V,lbVars.Items.Count);
//  
  for I:=0 to lbVars.Items.Count-1 do
    begin
      PVar:=PVarInfo(lbVars.Items.Objects[I]);
      //  
      V[I]:=PVar.Index;
      // 
      dispose(pVar);
    end;{for}
   //    Ultranet32
   UN32.DecInstance(V);
   V:=Unassigned;
   //    
   lbVars.Items.Clear;
   lbValues.Items.Clear;
end;
//--------------------------------------------------------------------------------------------------------------------
procedure TfrmDemo.btnGetValuesClick(Sender: TObject);
//       (    )
var
   IndexArray,ValArray:OleVariant; //   
   I,LenIndexArray,ValCount:integer;
   Val : integer; // 
   PVar:PVarInfo; //  ()
begin
//    Ultranet32
  if UN32=nil then exit;
//  
  IndexArray:=VarArrayCreate([0,0],varInteger);
  VarArrayRedim(IndexArray,lbVars.Items.Count);
  LenIndexArray:=VarArrayHighBound(IndexArray,1);
  for I:=0 to lbVars.Items.Count-1 do
    begin
      PVar:=PVarInfo(lbVars.Items.Objects[I]);
      IndexArray[I]:=PVar.Index;
    end;{for}
//     
    ValArray:=unassigned;
    ValArray:=UN32.GetValues(IndexArray);
    //     
    ValCount:=VarArrayHighBound(ValArray,1);
    //    ,  
    if ValCount<>LenIndexArray then
      exit;
    //  
    lbValues.Items.Clear;
    //  
    for I:=0 to LenIndexArray-1 do
      begin
        PVar:=PVarInfo(lbVars.Items.Objects[I]);
        //   
        Val:=ValArray[I];
        //   
        MakeValue(Val,PVar.Val);
        //   
        lbValues.Items.Add(ValueToStr(PVar.Val));
      end
end;
//--------------------------------------------------------------------------------------------------------------------
//          
procedure TfrmDemo.lbVarsClick(Sender: TObject);
var
  VarValue,VarType,VarName:string;
  PVar:PVarInfo;
  ValAndIndex:integer;
  HR:OleVariant;
begin
//    Ultranet32
  if UN32=nil then exit;
// , , 
  VarName:='';
  VarType:='';
  VarValue:='';
//   
  if lbVars.Items.Count>0 then
    begin
      //  
      PVar:=PVarInfo(lbVars.Items.Objects[lbVars.ItemIndex]);
      //  
      VarName:=pVar.Name;
      //  
      VarType:=TypeName[pVar.Val.Typ];
      //   ValAndIndex   
      ValAndIndex:=PVar.Index;
      //   
      HR:=UN32.GetValue(ValAndIndex);
     //   ValAndIndex    
      //  ,      lbVars
      LastVar:=PVar;
      //  ValAndIndex  
      MakeOleValue(HR,PVar.Val);
      //   
      VarValue:=ValueToStr(PVar.Val);
    end;
// ,      Edit-
  eVarName.Text:=VarName;
  eVarType.Text:=VarType;
  eVarValue.Text:=VarValue;
end;
//--------------------------------------------------------------------------------------------------------------------
//    (LastVar)  (         {XX.Name})
procedure TfrmDemo.btnSetValueByNameClick(Sender: TObject);
var
  fNode:integer;
  Value:OleVariant;
begin
//    Ultranet32       
  if (UN32=nil) and (LastVar<>nil) and (eNode.Text<>'') then exit;
//      
  StrToValue(eVarValue.Text,LastVar.Val);
// Integer    
  MakeOle(LastVar.Val,Value);
//  
  fNode:=StrToInt(eNode.Text);
//       SetValueByName('XX.Name','Type',Value)
  UN32.SetValueByName(IntToHex(fNode,2)+'.'+eVarName.Text,eVarType.Text,Value);
end;
//--------------------------------------------------------------------------------------------------------------------
//        Ultranet32)
procedure TfrmDemo.btnSetValueByIndexClick(Sender: TObject);
var
  Value:OleVariant;
begin
//    Ultranet32   
  if (UN32=nil) and (LastVar<>nil) then exit;
//      
  StrToValue(eVarValue.Text,LastVar.Val);
// Integer    
  MakeOle(LastVar.Val,Value);
//          Ultranet32
  UN32.SetValue(LastVar.Index,Value);
end;
//--------------------------------------------------------------------------------------------------------------------
//    lbValues    lbVars)
procedure TfrmDemo.btnSetValuesClick(Sender: TObject);
var
  OleIndexs,OleValues:OleVariant;
  I,Value:integer;
  StrValue:string;
  PVar:PVarInfo;
begin
//    Ultranet32
  if UN32=nil then exit;
//  
  OleIndexs:=VarArrayCreate([0,0], varInteger);
  VarArrayRedim(OleIndexs,lbVars.Items.Count);
//  
  OleValues:=VarArrayCreate([0,0], varInteger);
  VarArrayRedim(OleValues,lbVars.Items.Count);
//  
  for I:=0 to lbVars.Items.Count-1 do
    begin
      PVar:=PVarInfo(lbVars.Items.Objects[I]);
      // 
      OleIndexs[I]:=PVar.Index;
      //  -  
      StrValue:=lbValues.Items[I];
      //   
      StrToValue(StrValue,PVar.Val);
      //   Integer  
      Value:=VarValueToInteger(PVar.Val);
      // 
      OleValues[I]:=Value;
    end;
  //   
  Un32.SetValues(OleIndexs,OleValues);
end;
//--------------------------------------------------------------------------------------------------------------------
//        lbValues
procedure TfrmDemo.lbValuesClick(Sender: TObject);
var
  VarValue:string;
  PVar:PVarInfo;
  ValAndIndex:integer;
  HR:OleVariant;
begin
//    Ultranet32
  if UN32=nil then exit;
  VarValue:='';
//   
  if lbValues.Items.Count>0 then
    begin
      //       
      PVar:=PVarInfo(lbVars.Items.Objects[lbValues.ItemIndex]);
      // 
      ValAndIndex:=PVar.Index;
      // 
      HR:=UN32.GetValue(ValAndIndex);
      //   ValAndIndex    
      //  ,      lbValues
      LastListVar:=PVar;
      //  ValAndIndex  
      MakeOleValue(HR,PVar.Val);
      //   
      VarValue:=ValueToStr(PVar.Val);
    end;
//    Edit  
  eVarListValue.Text:=VarValue;
end;
//--------------------------------------------------------------------------------------------------------------------
//    (LastListVar)   lbValues
procedure TfrmDemo.btnSetValueToListClick(Sender: TObject);
var
  VarValue:string;
begin
//    Ultranet32
  if (UN32=nil) and (eVarListValue.Text='') then exit;
//   
  VarValue:=eVarListValue.Text;
//        
  if lbValues.Items.Count>0 then
    lbValues.Items[lbValues.ItemIndex]:=VarValue;
end;
//--------------------------------------------------------------------------------------------------------------------
end.

